#line 1 "D:/Stefan Popovic/Projekti/Click_ccRF_3_CC1120/example/ARM/SPI_Functions.c"
#line 1 "d:/stefan popovic/projekti/click_ccrf_3_cc1120/example/arm/spi_definitions.h"
#line 1 "d:/stefan popovic/projekti/click_ccrf_3_cc1120/example/arm/ccrf_3_registers.h"
#line 4 "D:/Stefan Popovic/Projekti/Click_ccRF_3_CC1120/example/ARM/SPI_Functions.c"
extern sfr sbit CCRF_3_CS;
extern sfr sbit CCRF_3_GP2;

char ccRF_SPICmdStrobe(char cmd){
 char rc;
 CCRF_3_CS = 0;
 asm NOP;
 rc = SPI3_Read(cmd);


 CCRF_3_CS = 1;
 asm NOP;
 return(rc);
}


void ccRF_ReadWriteBurstSingle(char addr,char *pData,unsigned len)
{
 unsigned i;

 if(addr &  0x80 )
 {
 if(addr &  0x40 )
 {
 for (i = 0; i < len; i++)
 {
 *pData++ = SPI3_Read(0);
 }
 }
 else
 {
 *pData = SPI3_Read(0);
 }
 }
 else
 {
 if(addr& 0x40 )
 {

 for (i = 0; i < len; i++)
 {
 SPI3_Write(*pData++);
 }
 }
 else
 {
 SPI3_Write(*pData);
 }
 }
 return;
}

char ccRF_8BitRegAccess(char accessType, char addrByte, char *pData, unsigned len)
{
 char readValue;
 char txtv[5];


 CCRF_3_CS = 0;
 asm NOP;

 readValue = SPI3_Read(accessType|addrByte);
 ccRF_ReadWriteBurstSingle(accessType|addrByte, pData, len);
 asm NOP;
 CCRF_3_CS = 1;

 return(readValue);
}

char ccRF_16BitRegAccess(char accessType, char extAddr, char regAddr, char *pData, char len)
{
 char readValue;
 CCRF_3_CS = 0;
 asm NOP;


 readValue = SPI3_Read(accessType|extAddr);
 SPI3_Write(regAddr);

 ccRF_ReadWriteBurstSingle(accessType|extAddr, pData, len);
 asm NOP;
 CCRF_3_CS = 1;

 return(readValue);
}

char ccRF_SpiWriteReg(unsigned addr, char *pData, char len){
 char tempExt = (char)(addr>>8);
 char tempAddr = (char)(addr & 0x00FF);
 char rc;


 if(( 0x003F  <= tempAddr) && (tempExt == 0)) return  0x80 ;


 if(!tempExt){
 rc = ccRF_8BitRegAccess(( 0x40 | 0x00 ), tempAddr, pData, len);
 }
 else if (tempExt == 0x2F){
 rc = ccRF_16BitRegAccess(( 0x40 | 0x00 ), tempExt, tempAddr, pData, len);
 }
 return (rc);
}

char ccRF_SPIReadReg(unsigned addr, char *pData, char len)
{
 char tempExt = (char)(addr>>8);
 char tempAddr = (char)(addr & 0x00FF);
 char rc;


 if(( 0x003F <=tempAddr)&&(tempExt==0)) return  0x80 ;


 if(!tempExt)
 {
 rc = ccRF_8BitRegAccess(( 0x40 | 0x80 ),tempAddr,pData,len);
 }
 else if (tempExt == 0x2F)
 {
 rc = ccRF_16BitRegAccess(( 0x40 | 0x80 ),tempExt,tempAddr,pData,len);
 }
 return (rc);
}

char ccRF_SPIWriteTxFifo(char *pData, char len)
{
 char rc;
 rc = ccRF_8BitRegAccess(0x00, 0x007F , pData, len);
 return (rc);
}

char ccRF_SPIReadRxFifo(char * pData, char len)
{
 char rc;
 rc = ccRF_8BitRegAccess(0x00, 0x00FF , pData, len);
 return (rc);
}

char ccRF_ReadGPIO2(){
 return CCRF_3_GP2;
}
